#include "stdafx.h"
#include "RecTest.h"
#include "AppMain.h"
#include "TvRock.h"
#include "resource.h"
#include <string>
#include <windows.h>
#include <tchar.h>

using namespace TvRock;

#define _FILE_EXTENSION		L".ts"


struct FreqInfo {
	WORD Frequency;
	WORD TSID;
};

static const FreqInfo BSChannelList[] = {
	{11727,	0x4010},	// BS1/TS0 BS
	{11727,	0x4011},	// BS1/TS1 BS-TBS
	{11766,	0x4030},	// BS3/TS0 WOWOW
	{11766,	0x4031},	// BS3/TS1 BSWp
	{11880,	0x4090},	// BS9/TS0 BS11
	{11880,	0x4091},	// BS9/TS1 Star Channel HV
	{11880,	0x4092},	// BS9/TS2 TwellV
	{11958,	0x40D0},	// BS13/TS0 BSe
	{11958,	0x40D1},	// BS13/TS1 BStW
	{11996,	0x40F1},	// BS15/TS1 NHK BS1/2
	{11996,	0x40F2},	// BS15/TS2 NHK BS-hi
	{12034,	0x4310},	// BS17/TS1 nfW΍
	{12034,	0x4311},	// BS17/TS2 nfW΍
};

static const FreqInfo CSChannelList[] = {
	{12291,	0x6020},	// ND2 110CS #1
	{12331,	0x7040},	// ND4 110CS #2
	{12371,	0x7060},	// ND6 110CS #3
	{12411,	0x6080},	// ND8 110CS #4
	{12451,	0x60A0},	// ND10 110CS #5
	{12491,	0x70C0},	// ND12 110CS #6
	{12531,	0x70E0},	// ND14 110CS #7
	{12571,	0x7100},	// ND16 110CS #8
	{12611,	0x7120},	// ND18 110CS #9
	{12651,	0x7140},	// ND20 110CS #10
	{12691,	0x7160},	// ND22 110CS #11
	{12731,	0x7180},	// ND24 110CS #12
};

// `l
class CChannelSearch {
private:
	int m_TerrestrialIndex;
	int m_TerrestrialIndex2;
	int m_BSIndex;
	int m_CSIndex;
	// --- JnFPX-S3U/W3PEΉ ---
	int m_CSStartChannel;  // BS/CS`[jOԂł́ACS̊Jn`lԍB
	// --- IFPX-S3U/W3PEΉ ---

	bool GetChannelInfo(int Space,int Channel,const CChannelInfo **ppChannelInfo) {
		const CChannelList *pChannelList=GetAppClass().GetChannelManager()->GetChannelList(Space);

		if (pChannelList==NULL)
			return false;
		*ppChannelInfo=pChannelList->GetChannelInfo(Channel);
		if (*ppChannelInfo==NULL)
			return false;
		return true;
	}

public:
	CChannelSearch()
		: m_TerrestrialIndex(-1)
		, m_TerrestrialIndex2(-1)
		, m_BSIndex(-1)
		, m_CSIndex(-1)
		// --- JnFPX-S3U/W3PEΉ ---
		, m_CSStartChannel(12)
		// ftHgl12BPX-S3UCS/ND2`lԍ12Ȃ̂ŁB
		// --- IFPX-S3U/W3PEΉ ---
	{
	}

	void SetProperty(RockProperty *pProp,LPCTSTR pszTerrestrialSpaceName) {
		// --- JnFPX-S3U/W3PEΉ ---
		WCHAR pszIniFileName[512];
		WCHAR strExePath[512] = L"";
		GetModuleFileName(NULL, strExePath, 512);

		WCHAR szPath[_MAX_PATH];
		WCHAR szDrive[_MAX_DRIVE];
		WCHAR szDir[_MAX_DIR];
		WCHAR szFname[_MAX_FNAME];
		WCHAR szExt[_MAX_EXT];
		_tsplitpath_s( strExePath, szDrive, _MAX_DRIVE, szDir, _MAX_DIR, szFname, _MAX_FNAME, szExt, _MAX_EXT );
		_tmakepath_s(  szPath, _MAX_PATH, szDrive, szDir, NULL, NULL );
		wcscat(pszIniFileName,szPath);
		wcscat(pszIniFileName,szFname);
		wcscat(pszIniFileName,L".ini");
		m_CSStartChannel = GetPrivateProfileInt(TEXT("Settings"),TEXT("CSStartChannel"),12,pszIniFileName);
		// --- IFPX-S3U/W3PEΉ ---

		CAppMain &AppClass=GetAppClass();
		int n=0;
		m_TerrestrialIndex = (pProp->UseTS() ? n++ : -1);
		m_BSIndex = (pProp->UseBS() ? n++ : -1);
		m_CSIndex = (pProp->UseCS() ? n++ : -1);

		AppClass.AddLog(TEXT("`[jOԂ̃CfbNX擾Ă܂..."));

		const CChannelInfo *pChannelInfo;
		if (m_TerrestrialIndex>=0) {
			bool fFound=false;
			if (pszTerrestrialSpaceName!=NULL && pszTerrestrialSpaceName[0]!='\0') {
				const CTuningSpaceList *pTuningSpaceList=AppClass.GetChannelManager()->GetDriverTuningSpaceList();

				for (int i=0;i<pTuningSpaceList->NumSpaces();i++) {
					if (::StrStrI(pTuningSpaceList->GetTuningSpaceName(i),pszTerrestrialSpaceName)!=NULL) {
						m_TerrestrialIndex=i;
						fFound=true;
						AppClass.AddLog(TEXT("nfW̃CfbNX擾܂B(%d)"),i);
						break;
					}
				}
				if (!fFound && ::lstrcmpi(pszTerrestrialSpaceName,TEXT("CATV"))==0) {
					for (int i=0;i<pTuningSpaceList->NumSpaces();i++) {
						if (::StrStr(pTuningSpaceList->GetTuningSpaceName(i),TEXT("P[u"))!=NULL) {
							m_TerrestrialIndex=i;
							fFound=true;
							AppClass.AddLog(TEXT("nfW̃CfbNX擾܂B(%d)"),i);
							break;
						}
					}
				}
			}
			if (!fFound) {
				if (GetChannelInfo(m_TerrestrialIndex,0,&pChannelInfo)
					&& ((pChannelInfo->GetTransportStreamID()&0xFF00)==0x7F00
						|| (pChannelInfo->GetTransportStreamID()&0xFF00)==0x7E00)) {
					fFound=true;
				} else {
					for (int i=0;GetChannelInfo(i,0,&pChannelInfo);i++) {
						if ((pChannelInfo->GetTransportStreamID()&0xFF00)==0x7F00
								|| (pChannelInfo->GetTransportStreamID()&0xFF00)==0x7E00) {
							m_TerrestrialIndex=i;
							fFound=true;
							break;
						}
					}
				}
				if (fFound)
					AppClass.AddLog(TEXT("nfW̃CfbNXTSID擾܂B(%d)"),m_TerrestrialIndex);
			}
			if (fFound
					&& GetChannelInfo(m_TerrestrialIndex+1,0,&pChannelInfo)
					&& ((pChannelInfo->GetTransportStreamID()&0xFF00)==0x7F00
						|| (pChannelInfo->GetTransportStreamID()&0xFF00)==0x7E00)) {
				m_TerrestrialIndex2=m_TerrestrialIndex+1;
				AppClass.AddLog(TEXT("nfW2̃CfbNX擾܂B(%d)"),m_TerrestrialIndex2);
			}
			if (!fFound) {
				AppClass.AddLog(TEXT("nfW̃CfbNX擾ł܂B%d ɉ肵܂B"),m_TerrestrialIndex);
			}
		}
		if (m_BSIndex>=0) {
			bool fFound=false;
			if (GetChannelInfo(m_BSIndex,0,&pChannelInfo)
					&& (pChannelInfo->GetTransportStreamID()&0xF000)==0x4000) {
				fFound=true;
			} else {
				for (int i=0;GetChannelInfo(i,0,&pChannelInfo);i++) {
					if ((pChannelInfo->GetTransportStreamID()&0xF000)==0x4000) {
						m_BSIndex=i;
						fFound=true;
						break;
					}
				}
			}
			if (fFound) {
				AppClass.AddLog(TEXT("BS̃CfbNXTSID擾܂B(%d)"),m_BSIndex);
			} else {
				const CTuningSpaceList *pTuningSpaceList=AppClass.GetChannelManager()->GetTuningSpaceList();

				for (int i=0;i<pTuningSpaceList->NumSpaces();i++) {
					if (pTuningSpaceList->GetTuningSpaceType(i)==CTuningSpaceInfo::SPACE_BS) {
						m_BSIndex=i;
						fFound=true;
						AppClass.AddLog(TEXT("BS̃CfbNX擾܂B(%d)"),i);
						break;
					}
				}
				if (!fFound) {
					AppClass.AddLog(TEXT("BS̃CfbNX擾ł܂B%d ɉ肵܂B"),m_BSIndex);
				}
			}
		}
		if (m_CSIndex>=0) {
			bool fFound=false;
			if (GetChannelInfo(m_CSIndex,0,&pChannelInfo)
					&& ((pChannelInfo->GetTransportStreamID()&0xF000)==0x6000
					|| ((pChannelInfo->GetTransportStreamID()&0xF000)==0x7000
						&& (pChannelInfo->GetTransportStreamID()&0x0F00)<0x0E00))) {
				fFound=true;
			} else {
				for (int i=0;GetChannelInfo(i,0,&pChannelInfo);i++) {
					WORD TSID=pChannelInfo->GetTransportStreamID();
					if ((TSID&0xF000)==0x6000
							|| ((TSID&0xF000)==0x7000 && (TSID&0x0F00)<0x0E00)) {
						m_CSIndex=i;
						fFound=true;
						break;
					}
				}
			}
			if (fFound) {
				AppClass.AddLog(TEXT("CS̃CfbNXTSID擾܂B(%d)"),m_CSIndex);
			} else {
				const CTuningSpaceList *pTuningSpaceList=AppClass.GetChannelManager()->GetTuningSpaceList();

				for (int i=0;i<pTuningSpaceList->NumSpaces();i++) {
					if (pTuningSpaceList->GetTuningSpaceType(i)==CTuningSpaceInfo::SPACE_110CS) {
						m_CSIndex=i;
						fFound=true;
						AppClass.AddLog(TEXT("CS̃CfbNX擾܂B(%d)"),i);
						break;
					}
				}
				if (!fFound) {
					AppClass.AddLog(TEXT("CS̃CfbNX擾ł܂B%d ɉ肵܂B"),m_CSIndex);
				}
			}
		}
	}

	bool SetChannel(const DWORD dwChannel, const DWORD dwService) {
		const CChannelManager *pChannelManager=GetAppClass().GetChannelManager();
		const CChannelList *pChannelList;
		const CChannelInfo *pChannelInfo;

		if (m_TerrestrialIndex>=0 && dwChannel<=63) {
			if (dwChannel!=0) {
				// `l̃CfbNX/T[rXIDɈv`lT
				for (int j=0;j<2;j++) {
					const int Space=j==0?m_TerrestrialIndex:m_TerrestrialIndex2;
					if (Space<0)
						break;
					pChannelList=pChannelManager->GetChannelList(Space);
					if (pChannelList==NULL)
						break;
					for (int i=0;i<pChannelList->NumChannels();i++) {
						pChannelInfo=pChannelList->GetChannelInfo(i);
						if (pChannelInfo->GetChannelIndex()==(int)dwChannel-13
								&& (dwService==0 || pChannelInfo->GetServiceID()==dwService))
							return GetAppClass().SetChannel(Space,i);
					}
				}
			}
			if (dwService!=0) {
				// T[rXID̈v`lT
				for (int j=0;j<2;j++) {
					const int Space=j==0?m_TerrestrialIndex:m_TerrestrialIndex2;
					if (Space<0)
						break;
					pChannelList=pChannelManager->GetChannelList(Space);
					if (pChannelList==NULL)
						break;
					for (int i=0;i<pChannelList->NumChannels();i++) {
						pChannelInfo=pChannelList->GetChannelInfo(i);
						if (pChannelInfo->GetServiceID()==dwService)
							return GetAppClass().SetChannel(Space,i);
					}
				}
			}
			if (dwChannel!=0) {
				// `l̃CfbNẌv`lT
				for (int j=0;j<2;j++) {
					const int Space=j==0?m_TerrestrialIndex:m_TerrestrialIndex2;
					if (Space<0)
						break;
					pChannelList=pChannelManager->GetChannelList(Space);
					if (pChannelList==NULL)
						break;
					for (int i=0;i<pChannelList->NumChannels();i++) {
						pChannelInfo=pChannelList->GetChannelInfo(i);
						if (pChannelInfo->GetChannelIndex()==(int)dwChannel-13)
							return GetAppClass().SetChannel(Space,i,(int)dwService);
					}
				}
			}
			goto NotFound;
		}
		if (m_BSIndex>=0) {
			WORD Frequency=(WORD)(dwChannel>>16),TSID=(WORD)(dwChannel&0xFFFF);

			for (int i=0;i<lengthof(BSChannelList);i++) {
				if (BSChannelList[i].Frequency==Frequency
						&& (TSID==0 || BSChannelList[i].TSID==TSID)) {
					pChannelList=pChannelManager->GetChannelList(m_BSIndex);
					if (pChannelList==NULL)
						return false;
					for (int j=0;j<pChannelList->NumChannels();j++) {
						pChannelInfo=pChannelList->GetChannelInfo(j);
						if (pChannelInfo->GetChannelIndex()==i
								&& pChannelInfo->GetServiceID()==dwService)
							return GetAppClass().SetChannel(m_BSIndex,j);
					}
					for (int j=0;j<pChannelList->NumChannels();j++) {
						pChannelInfo=pChannelList->GetChannelInfo(j);
						if (pChannelInfo->GetChannelIndex()==i)
							return GetAppClass().SetChannel(m_BSIndex,j,(int)dwService);
					}
					goto NotFound;
				}
			}
		}
		
		// --- JnFPX-S3U/W3PEΉ ---
		if (m_CSIndex>=0 && (m_BSIndex==m_CSIndex)) {
			WORD Frequency=(WORD)(dwChannel>>16),TSID=(WORD)(dwChannel&0xFFFF);

			for (int i=0;i<lengthof(CSChannelList);i++) {
				if (CSChannelList[i].Frequency==Frequency
						/*&& (TSID==0 || CSChannelList[i].TSID==TSID)*/) {
					pChannelList=pChannelManager->GetChannelList(m_CSIndex);
					if (pChannelList==NULL)
						return false;
					for (int j=0;j<pChannelList->NumChannels();j++) {
						pChannelInfo=pChannelList->GetChannelInfo(j);
						if ((pChannelInfo->GetChannelIndex()-m_CSStartChannel)==i
								&& pChannelInfo->GetServiceID()==dwService)
							return GetAppClass().SetChannel(m_CSIndex,j);
					}
					for (int j=0;j<pChannelList->NumChannels();j++) {
						pChannelInfo=pChannelList->GetChannelInfo(j);
						if ((pChannelInfo->GetChannelIndex()-m_CSStartChannel)==i)
							return GetAppClass().SetChannel(m_CSIndex,j,(int)dwService);
					}
					goto NotFound;
				}
			}
		}
		// --- IFPX-S3U/W3PEΉ ---

		if (m_CSIndex>=0) {
			WORD Frequency=(WORD)(dwChannel>>16),TSID=(WORD)(dwChannel&0xFFFF);

			for (int i=0;i<lengthof(CSChannelList);i++) {
				if (CSChannelList[i].Frequency==Frequency
						/*&& (TSID==0 || CSChannelList[i].TSID==TSID)*/) {
					pChannelList=pChannelManager->GetChannelList(m_CSIndex);
					if (pChannelList==NULL)
						return false;
					for (int j=0;j<pChannelList->NumChannels();j++) {
						pChannelInfo=pChannelList->GetChannelInfo(j);
						if (pChannelInfo->GetChannelIndex()==i
								&& pChannelInfo->GetServiceID()==dwService)
							return GetAppClass().SetChannel(m_CSIndex,j);
					}
					for (int j=0;j<pChannelList->NumChannels();j++) {
						pChannelInfo=pChannelList->GetChannelInfo(j);
						if (pChannelInfo->GetChannelIndex()==i)
							return GetAppClass().SetChannel(m_CSIndex,j,(int)dwService);
					}
					goto NotFound;
				}
			}
		}
	NotFound:
		GetAppClass().AddLog(TEXT("Y`l܂B"));
		return false;
	}

	DWORD GetChannel() {
		const CChannelInfo *pChannelInfo=GetAppClass().GetChannelManager()->GetCurrentChannelInfo();

		if (pChannelInfo==NULL)
			return 0;
		DWORD Channel=pChannelInfo->GetChannelIndex();
		if (pChannelInfo->GetSpace()==m_TerrestrialIndex
				|| pChannelInfo->GetSpace()==m_TerrestrialIndex2) {
			/*
			if (ChannelInfo.PhysicalChannel!=0)
				return ChannelInfo.PhysicalChannel;
			*/
			return (Channel+13);
		}

		// --- JnFPX-S3U/W3PEΉ ---
		if ((pChannelInfo->GetSpace()==m_BSIndex) && (m_BSIndex==m_CSIndex)) {
			if (Channel<sizeof(BSChannelList)/sizeof(FreqInfo))
				return (BSChannelList[Channel].Frequency<<16)|
						BSChannelList[Channel].TSID;
			} else {
			if (Channel<sizeof(CSChannelList)/sizeof(FreqInfo))
				return (CSChannelList[Channel-m_CSStartChannel].Frequency<<16)|
						CSChannelList[Channel-m_CSStartChannel].TSID;
		}
		// --- IFPX-S3U/W3PEΉ ---

		if (pChannelInfo->GetSpace()==m_BSIndex) {
			if (Channel<sizeof(BSChannelList)/sizeof(FreqInfo))
				return (BSChannelList[Channel].Frequency<<16)|
						BSChannelList[Channel].TSID;
		}
		if (pChannelInfo->GetSpace()==m_CSIndex) {
			if (Channel<sizeof(CSChannelList)/sizeof(FreqInfo))
				return (CSChannelList[Channel].Frequency<<16)|
						CSChannelList[Channel].TSID;
		}
		return 0;
	}
};




// TvRock̗v󂯎NX
class CTvRockRequest : public RockRequest
{
	CChannelSearch *m_pChannel;

public:
	CTvRockRequest(CChannelSearch *pChannel) {
		m_pChannel = pChannel;
	}
	// AvI̗v
	void PowerOff() {
		GetAppClass().AddLog(TEXT("TvRockIv󂯂܂B"));
		GetAppClass().GetMainWindow()->SendCommand(CM_EXIT);
	}
	// `lύX̗v
	bool ChannelChange(const DWORD dwChannel, const DWORD dwService) {
		GetAppClass().AddLog(TEXT("TvRock`lύXv󂯂܂B(Ch %lu Sv %lu)"),dwChannel,dwService);
		return (m_pChannel ? m_pChannel->SetChannel(dwChannel, dwService) : false);
	}
	// ^Jn̗v
	bool RecordStart(LPWSTR lpFileName) {
		GetAppClass().AddLog(TEXT("TvRock^Jnv󂯂܂B(%s)"),lpFileName);
		return GetAppClass().StartRecord(lpFileName);
	}
	// NCbN^Jn̗v (Rocko[̒ژ^̗v)
	bool QuickRecord(LPWSTR lpFileName) {
		GetAppClass().AddLog(TEXT("TvRockNCbN^Jnv󂯂܂B(%s)"),lpFileName);
		return RecordStart(lpFileName);
	}
	// ^~̗v
	bool RecordStop() {
		GetAppClass().AddLog(TEXT("TvRock^~v󂯂܂B"));
		GetAppClass().GetMainWindow()->SendCommand(CM_RECORD_STOP);
		return true;
	}
	// Î~ۑ̗v
	void ScreenCapture() {
		GetAppClass().AddLog(TEXT("TvRockÎ~ۑv󂯂܂B"));
	}
	// IvV{^̗v
	void OnOption() {
		GetAppClass().AddLog(TEXT("TvRockIvV{^̗v󂯂܂B"));
	}
	// rfIEBhEnh̗v (Rocko[E^bvEEBhETCYύX)
	HWND GetVideoHandle() {
		return GetAppClass().GetMainWindow()->GetHandle();
	}
	// ^[Qbg̎擾
	void CollectSetting() {
	}
	// bZ[W
	LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam) {
		return 0;
	}
};




CTvRockDTVTarget::CTvRockDTVTarget()
	: m_hPlugin(NULL)
	, m_pTvRock(NULL)
	, m_pRequest(NULL)
	, m_pChannel(NULL)
	, m_DeviceID(-1)
	, m_hProcessTSEvent(NULL)
	, m_StreamBufferLength(DEFAULT_BUFFER_LENGTH)
	, m_pStreamBuffer(NULL)
	, m_StreamSendBufferLength(DEFAULT_SEND_BUFFER_LENGTH)
	, m_hStreamThread(NULL)
	, m_fStreamEnd(false)
	, m_StreamBufferUsed(0)
	, m_StreamBufferPos(0)
	, m_DropCount(0)
{
	m_szTerrestrialSpaceName[0]='\0';
}


CTvRockDTVTarget::~CTvRockDTVTarget()
{
	Finalize();
}


bool CTvRockDTVTarget::Initialize()
{
	typedef TvRockDTV *(*CreateTvRockDTV)(HINSTANCE);

	Trace(TEXT("TvRockDTVTarget̏sĂ܂..."));

	// TvRockDTVCu̓ǂݍ
	Trace(TEXT("TvRockDTVCuǂݍł܂..."));
	m_hPlugin = LoadDTVModule();
	if (m_hPlugin==NULL) {
		SetError(TEXT("TvRockDTVCu܂B"));
		return false;
	}

	Trace(TEXT("TvRockDTVNX擾Ă܂..."));
	CreateTvRockDTV pFunc = (CreateTvRockDTV)GetProcAddress(m_hPlugin, "CreateTvRockDTV");
	if (pFunc == NULL) {
		FreeLibrary(m_hPlugin);
		m_hPlugin=NULL;
		SetError(TEXT("TvRockDTVCuv܂B"));
		return false;
	}
	m_pTvRock = pFunc(m_hPlugin);

	// TvRock̓foCXʔԍKv
	Trace(TEXT("foCXʔԍ擾Ă܂..."));
	int argc;
	LPTSTR* argv=CommandLineToArgvW(GetCommandLine(), &argc);
	bool fFindDID=false;
	if (argv != NULL) {
		for (int i=0; i<(argc-1); i++) {
			if (::lstrcmpiW(argv[i], L"/DID")==0) {
				fFindDID=true;
				if (argv[i+1][0] >= L'A' && argv[i+1][0] <= L'H') {
					m_DeviceID = (argv[i+1][0] - L'A');
					break;
				} else if (argv[i+1][0] >= L'a' && argv[i+1][0] <= L'h') {
					m_DeviceID = (argv[i+1][0] - L'a');
					break;
				}
			}
		}
		LocalFree(argv);
	}
	if (m_DeviceID<0) {
		FreeLibrary(m_hPlugin);
		m_hPlugin=NULL;
		SetError(fFindDID?TEXT("foCXʔԍsłB"):
				 TEXT("foCXʔԍݒ肳Ă܂B"));
		return false;
	}

	// TvRock DTV Target (ɃfoCX݂ꍇG[)
	Trace(TEXT("TvRock̏sĂ܂(DID = %c)..."),m_DeviceID+'A');
	m_pChannel = new CChannelSearch();
	m_pRequest = new CTvRockRequest(m_pChannel);
	if (!m_pTvRock->Initialize(m_DeviceID,m_pRequest)) {
		TCHAR szText[128];
		::wsprintf(szText,TEXT("TvRock̏ł܂B"));
		SetError(szText);
		m_pTvRock->Dispose();
		delete m_pTvRock;
		delete m_pRequest;
		m_pTvRock = NULL;
		m_pRequest = NULL;
		return false;
	}

	// ݒ̊mF
	Trace(TEXT("ݒ̊mFsĂ܂..."));
	RockProperty *m_pProp = m_pTvRock->GetProperty();
	if (m_pProp) {
		// ^t@Cgq̒
		WCHAR ext[MAX_PATH];
		memset(ext,0,sizeof(ext));
		m_pProp->GetFileExtension(ext, MAX_PATH);
		if (wcscmp(ext,_FILE_EXTENSION)) {
			m_pProp->SetFileExtension(_FILE_EXTENSION);
			m_pProp->Notify();
		}
		if (m_pChannel)
			m_pChannel->SetProperty(m_pProp,m_szTerrestrialSpaceName);
#if 0
		// pXTVTestɍ킹ꍇ
		TCHAR m_szSetting[MAX_PATH];
		TCHAR m_szModFile[MAX_PATH];
		TCHAR m_szModPath[MAX_PATH];
		TCHAR m_szFilePath[MAX_PATH];
		memset(m_szModFile, 0, sizeof(m_szModFile));
		if ( GetModuleFileName(NULL, m_szModFile, MAX_PATH) ) {
			PathRemoveFileSpec(m_szModFile);
			memset(m_szModPath, 0, sizeof(m_szModPath));
			PathCombine(m_szModPath, m_szModFile, _TVTEST_SETTING);
			memset(m_szSetting, 0, sizeof(m_szSetting));
			memset(m_szFilePath, 0, sizeof(m_szFilePath));
			GetPrivateProfileString(L"Settings", TEXT("RecordFolder"), TEXT("C:\\"), m_szFilePath, MAX_PATH, m_szModPath);
			m_pProp->GetRecordPath(ext, MAX_PATH);
			if (wcscmp(ext,m_szFilePath)) {
				m_pProp->SetRecordPath(m_szFilePath);
				m_pProp->Notify();
			}
		}
#endif
	}

	Trace(TEXT("TvRockXg[~OXbhJnĂ܂..."));
	m_pStreamBuffer = new BYTE[m_StreamBufferLength*188];
	m_StreamBufferUsed = 0;
	m_StreamBufferPos = 0;
	m_hProcessTSEvent = ::CreateEvent(NULL,FALSE,FALSE,NULL);
	m_hStreamThread = ::CreateThread(NULL,0,StreamThread,this,0,NULL);
	GetAppClass().GetCoreEngine()->m_DtvEngine.m_TvRockGrabber.SetMediaGrabCallback(StreamCallback,this);

	ClearError();

	Trace(TEXT("TvRockDTVTarget̏܂B"));

	return true;
}


bool CTvRockDTVTarget::Finalize()
{
	Trace(TEXT("TvRockDTVTarget̏IsĂ܂..."));

	GetAppClass().GetCoreEngine()->m_DtvEngine.m_TvRockGrabber.SetMediaGrabCallback(NULL);

	if (m_hStreamThread) {
		Trace(TEXT("TvRockXg[~OXbh~Ă܂..."));
		m_fStreamEnd=true;
		if (::WaitForSingleObject(m_hStreamThread,2000)==WAIT_TIMEOUT) {
			::TerminateThread(m_hStreamThread,1);
			Trace(TEXT("TvRockXg[~OXbhI܂B"));
		}
		::CloseHandle(m_hStreamThread);
		m_hStreamThread=NULL;
	}
	if (m_hProcessTSEvent) {
		::CloseHandle(m_hProcessTSEvent);
		m_hProcessTSEvent=NULL;
	}
	SAFE_DELETE(m_pStreamBuffer);

	// TvRockDTVTargetp
	if (m_pTvRock) {
		Trace(TEXT("TvRockDTVTargetpĂ܂..."));
		m_pTvRock->Dispose();
		delete m_pTvRock;
		delete m_pRequest;
		m_pTvRock = NULL;
		m_pRequest = NULL;
	}
	SAFE_DELETE(m_pChannel);
	if (m_hPlugin) {
		Trace(TEXT("TvRockDTVCuJĂ܂..."));
		FreeLibrary(m_hPlugin);
		m_hPlugin=NULL;
	}

	Trace(TEXT("TvRockDTVTarget̏I܂B"));

	return true;
}


void CTvRockDTVTarget::OnEvent(UINT Event)
{
	switch (Event) {
	case EVENT_CHANNELCHANGE:
	case EVENT_DRIVERCHANGE:
		PurgeStream();
	case EVENT_SERVICECHANGE:
	case EVENT_SERVICEUPDATE:
		if (m_pTvRock) {
			DWORD Channel;
			CDtvEngine *pDtvEngine=&GetAppClass().GetCoreEngine()->m_DtvEngine;
			WORD Service,ServiceID;

			if (m_pChannel==NULL || (Channel=m_pChannel->GetChannel())==0)
				return;
			Service=pDtvEngine->GetService();
			if (pDtvEngine->m_ProgManager.GetServiceID(&ServiceID,Service))
				m_pTvRock->OnStreamChange(Channel, ServiceID);
		}
		break;
	}
}


void CTvRockDTVTarget::ProcessTS(BYTE *pData, DWORD Length)
{
	static DWORD dwCount = 0;

	if (m_pTvRock) {
		m_pTvRock->ProcessTS(pData, Length);
		RockStatus *Stat = m_pTvRock->GetStatus();
		if (!Stat)
			return;
		dwCount += Length;
		if (dwCount >= 0x100000) {
			const CCoreEngine *pCoreEngine=GetAppClass().GetCoreEngine();

			Stat->SetStatusSignalLevel(pCoreEngine->GetSignalLevel());
			Stat->SetStatusBitrate(pCoreEngine->GetBitRate()*8);
			Stat->SetStatusErrorPacket(pCoreEngine->GetErrorPacketCount()+
									   pCoreEngine->GetContinuityErrorPacketCount());
			Stat->SetStatusScramblingPacket(pCoreEngine->GetScramblePacketCount());
			dwCount -= 0x100000;
		}
	}
}


bool CTvRockDTVTarget::GetStream(BYTE *pBuffer,SIZE_T *pBufferLength)
{
	m_StreamLock.Lock();
	if (m_StreamBufferUsed == 0) {
		m_StreamLock.Unlock();
		return false;
	}
	SIZE_T Size = min(*pBufferLength,m_StreamBufferUsed);
	if (Size > m_StreamBufferLength-m_StreamBufferPos)
		Size = m_StreamBufferLength-m_StreamBufferPos;
	::CopyMemory(pBuffer,m_pStreamBuffer+m_StreamBufferPos*188,Size*188);
	*pBufferLength = Size;
	m_StreamBufferPos += Size;
	if (m_StreamBufferPos == m_StreamBufferLength)
		m_StreamBufferPos = 0;
	m_StreamBufferUsed -= Size;
	m_StreamLock.Unlock();
	return true;
}


void CTvRockDTVTarget::PurgeStream()
{
	m_StreamLock.Lock();
	m_StreamBufferUsed = 0;
	m_StreamBufferPos = 0;
	m_StreamLock.Unlock();
	::ResetEvent(m_hProcessTSEvent);
	::WaitForSingleObject(m_hProcessTSEvent,INFINITE);
}


DWORD WINAPI CTvRockDTVTarget::StreamThread(LPVOID lpParameter)
{
	CTvRockDTVTarget *pThis=static_cast<CTvRockDTVTarget*>(lpParameter);
	BYTE *pBuffer = new BYTE[pThis->m_StreamSendBufferLength*188];
	while (!pThis->m_fStreamEnd) {
		SIZE_T Length = pThis->m_StreamSendBufferLength;
		if (pThis->GetStream(pBuffer,&Length)) {
			pThis->ProcessTS(pBuffer, Length*188);
			::SetEvent(pThis->m_hProcessTSEvent);
		} else {
			::SetEvent(pThis->m_hProcessTSEvent);
			::Sleep(5);
		}
	}
	delete [] pBuffer;
	return 0;
}


bool CALLBACK CTvRockDTVTarget::StreamCallback(const CMediaData *pMediaData,const PVOID pParam)
{
	CTvRockDTVTarget *pThis = static_cast<CTvRockDTVTarget*>(pParam);

	pThis->m_StreamLock.Lock();
	if (pThis->m_StreamBufferUsed == pThis->m_StreamBufferLength) {
		pThis->m_DropCount++;
		pThis->m_StreamLock.Unlock();
		return TRUE;
	}
	::CopyMemory(pThis->m_pStreamBuffer+(pThis->m_StreamBufferPos+pThis->m_StreamBufferUsed)%pThis->m_StreamBufferLength*188,pMediaData->GetData(),188/*pMediaData->GetSize()*/);
	pThis->m_StreamBufferUsed++;
	pThis->m_StreamLock.Unlock();
	return true;
}


void CTvRockDTVTarget::SetTerrestrialSpace(LPCTSTR pszName)
{
	if (pszName==NULL)
		m_szTerrestrialSpaceName[0]='\0';
	else
		::lstrcpyn(m_szTerrestrialSpaceName,pszName,lengthof(m_szTerrestrialSpaceName));
}
